package de.hdm_stuttgart.mi.sd1.test.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task2._5_DayConverter;

import de.hdm_stuttgart.mi.sd1.test.ignore_me.ObjectWrapper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_5_DayConverter extends ExaminationTestDefaults {

  private static void checkYearsWeeksDays(final int overallDayPeriod,
                                          final int yearsExpected, final int weeksExpected, final int daysExpected){

    final ObjectWrapper<_5_DayConverter> converter =
            new ObjectWrapper<>(_5_DayConverter.class, overallDayPeriod);

    Assert.assertEquals(yearsExpected, (int) converter.get(int.class, "years"));
    Assert.assertEquals(weeksExpected, (int) converter.get(int.class, "weeks"));
    Assert.assertEquals(daysExpected, (int) converter.get(int.class, "days"));
  }

  @Test @Marking(points = 5) public void test_080_small() {
    checkYearsWeeksDays(6,0, 0, 6);
    checkYearsWeeksDays(7,0, 1, 0);
    checkYearsWeeksDays(3 * 7 + 5,0, 3, 5);
  }

  @Test  @Marking(points = 5) public void test_100_fullYears() {
    checkYearsWeeksDays(365,1, 0, 0);
    checkYearsWeeksDays(2 * 365,2, 0, 0);
    checkYearsWeeksDays(7 * 365,7, 0, 0);
    checkYearsWeeksDays(11* 365,11, 0, 0);
    checkYearsWeeksDays(22* 365,22, 0, 0);
  }

  @Test  @Marking(points = 5) public void test_120_mixed() {

    checkYearsWeeksDays(365 + 5 * 7 + 3,1, 5, 3);
    checkYearsWeeksDays(2 * 365 + 5 * 7 + 1,2, 5, 1);
    checkYearsWeeksDays(3 * 365 + 2 * 7 + 2,3, 2, 2);
    checkYearsWeeksDays(11 * 365 + 11 * 7 + 6,11, 11, 6);

  }

  @Test  @Marking(points = 5) public void test_900_immutable() {

    final ObjectWrapper<_5_DayConverter> converter =
            new ObjectWrapper<>(_5_DayConverter.class, 0);

    ObjectWrapper.assertFinal(_5_DayConverter.class, "years");
    ObjectWrapper.assertFinal(_5_DayConverter.class, "weeks");
    ObjectWrapper.assertFinal(_5_DayConverter.class, "days");
  }
}
