package de.hdm_stuttgart.mi.sd1.task1;

import static org.junit.Assert.assertEquals;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.task1.Helper;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

/**
 * Testing {@link Helper#getMaxAbsoluteDiff(int, int, int)}.
 *
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestHelperMaxAbsDiff extends ExaminationTestDefaults {

  @Test
  public void test01Zero() {
    assertEquals(0, Helper.getMaxAbsoluteDiff(0, 0, 0));
  }

  @Test
  public void test02Equal() {
    assertEquals(0, Helper.getMaxAbsoluteDiff(1, 1, 1));
  }

  @Test
  public void test03AscendingValues() {
    assertEquals(2, Helper.getMaxAbsoluteDiff(1, 2, 3));
  }

  @Test
  public void test04DescendingValues() {
    assertEquals(7, Helper.getMaxAbsoluteDiff(7, 5, 0));
  }

  @Test
  public void test05Middle() {
    assertEquals(3, Helper.getMaxAbsoluteDiff(4, 1, 4));
  }

  @Test
  public void test06Negative() {
    assertEquals(3, Helper.getMaxAbsoluteDiff(-1, -2, -4));
  }

  @Test
  public void test07Mixed() {
    assertEquals(15, Helper.getMaxAbsoluteDiff(-5, 10, 0));
    assertEquals(37, Helper.getMaxAbsoluteDiff(-5, 30, -7));
  }
}
